#!/bin/bash
user=$(whoami)
if [[ ${user} -ne "root" ]]; then
    echo "The bcc module must be run under the root user" >&2
    exit 1
fi

DEBUGFS_PATH="/sys/kernel/debug"
debugfs_flag=$(mount -l | grep "type debugfs")
if [[ -z "${debugfs_flag}" ]]; then
    mount -t debugfs debugfs "${DEBUGFS_PATH}"
    mount_result=$?
    if [[ "${mount_result}" -ne "0" ]]; then
        echo "Mount debugfs failed" >&2
        exit 1
    fi
fi

bcc_cmd=$@
${bcc_cmd}
exec_result=$?

if [[ -z "${debugfs_flag}" ]]; then
    umount "${DEBUGFS_PATH}" >> /dev/null 2>&1
fi
exit "${exec_result}"