#!/bin/bash
CURRENT_DIR=$(cd $(dirname "$0"); pwd)

function findDir(){
    local dir=$1
    local prefix=$2
    find "$dir" -name "${prefix}*"
}
WORKPATH=$1
OUTPUTPATH=$2
OPENSOURCE_DIR=$3
bcc_python_dir=$(findDir $OPENSOURCE_DIR/local/bcc/lib python)
bcc_python_site_path=${bcc_python_dir}/site-packages
bcc_bpf_so_path=$OPENSOURCE_DIR/local/bcc/lib64/libbcc_bpf.so.0
bcc_so_path=$OPENSOURCE_DIR/local/bcc/lib64/libbcc.so.0
stdlib_path=${OPENSOURCE_DIR}/WeakConsistency/libstdc++.so.6

# -F 参数打包为一个可执行文件时，执行时会在/tmp中写入so，有些环境/tmp 有noexec，会造成执行失败, 而且不会因失败进程失败，而导致临时文件未被删除
# 将当前目录下的entrance.py文件打包成二进制文F件
cd $WORKPATH
pyinstaller -F ${CURRENT_DIR}/../python_script/hyper_tuner_memleak.py --distpath ${OUTPUTPATH} \
    --workpath ${WORKPATH} --noconfirm --runtime-tmpdir . \
    -p ${bcc_python_site_path}:${CURRENT_DIR}/../:${CURRENT_DIR}/ \
    --add-data ${bcc_bpf_so_path}:. --add-data ${bcc_so_path}:. --add-data ${stdlib_path}:.