#!/bin/bash
#Description: fio.sh
#Copyright: Copyright © Huawei Technologies Co., Ltd. 2020. All rights reserved.
#History: 2021-10-21 created
count=0
file_path=""
file_path_arr=()

function check_file_exists()
{
  for file in ${file_path_arr[@]};
  do
    if [[ -f $file ]]; then
      echo "file exists"
      exit 121
    fi
    remove_file ${file}
  done
}

function kill_process()
{
  while true; do
    process_state=$(ps -o pid,state -ax | grep -w "$!" | awk '$1=$1' | cut -d" " -f2)
    if [[ $process_state =~ "D" ]]; then
      sleep 1
    else
      sleep 1
      break
    fi
  done
  /usr/bin/devkit_tools/kill_process.sh $! 9
  sleep 3
}

function task_clean()
{
  echo $!
  kill_process
}

function remove_file()
{
  if [[ $1 == "/dev/"* ]]; then
    return
  fi
  chmod 400 "$1"
  rm -rf "$1"
}

for args in "$@"
do
    if [[ -x "${args}" ]]
    then
        echo "The parameters of fio.sh script must be unexecutable"
        exit 1
    fi
    if [[ "$args" == "-filename="* ]]; then
        if [[ "$count" == "0" ]]; then
            let count++
	          file_path_arr=($(echo ${args#*=} | awk -F ":" '{for(i=1;i<=NF;i++) print $i}'))
            check_file_exists
        else
            # filename 参数重复退出
            echo "filename parameter duplicate"
            exit 111
        fi
    fi
done
fio_path=$(which fio)
if [[ "$?" != "0" ]]; then
    echo "fio: command not found"
    exit 1
fi
trap 'task_clean' SIGTERM

${fio_path} $* &
# wait 用于 trap 信号
wait $!
for file in ${file_path_arr[@]};
do
  remove_file $file
done