#!/bin/bash
#Description: launch app under ordinary user launcher
#Copyright: Copyright © Huawei Technologies Co., Ltd. 2020. All rights reserved.
#History: 2023-11-27 created
error=1
owner=$1
task_param=$2
destination_dir=$3
task_type=$4
DEVKIT_TOOL_PATH="/usr/bin/devkit_tools"
origin_dir="/tmp/memdiagnostic"
owner_group=${owner}


function check_file() {
  for param in $@
  do
    # 硬链接判断
    if [[ -h "${param}" ]];then
      return 1
    # 软连接判断
    elif [[ -L "${param}" ]]; then
      return 1
    fi
  done
  return 0
}

if [[ "${owner}" == *"devkit"* ]];then
        owner_group="devkit"
fi

# 检查origin_dir是否有软连接或者硬链接，如果有直接退出
check_file ${origin_dir}
if [[ "$?" == 1 ]];then
      exit ${error}
fi

if [ ! -d "${origin_dir}" ];then
    mkdir ${origin_dir}
    echo "2"
    ${DEVKIT_TOOL_PATH}/chown_binary ${owner}:${owner_group} ${origin_dir}
    ${DEVKIT_TOOL_PATH}/chmod_binary 700 ${origin_dir}
fi

while :
do
    if [ ! -d "${destination_dir}" ];then
        ${DEVKIT_TOOL_PATH}/echo_binary "${destination_dir} not exist"
        exit ${error}
    fi
    cd "${origin_dir}"
    files=$(ls *.txt.[0-9]* asan.log.[0-9]* 2>/dev/null)
    for file in ${files};
    do
        check_file ${file}
        if [[ "$?" == 1 ]];then
          continue
        fi
        ${DEVKIT_TOOL_PATH}/cp_binary ${file} ${destination_dir}
        check_file ${destination_dir}/${file}
        if [[ "$?" == 1 ]];then
          continue
        fi
        ${DEVKIT_TOOL_PATH}/chown_binary devkit:devkit ${destination_dir}/${file}
        check_file ${destination_dir}/${file}
        if [[ "$?" == 1 ]];then
          continue
        fi
        ${DEVKIT_TOOL_PATH}/chmod_binary 500 ${destination_dir}/${file}
    done
    sleep 1
done
