#!/bin/bash
#Description: plugin agent uninstall entry
#Copyright: Copyright © Huawei Technologies Co., Ltd. 2023. All rights reserved.
#History: 2023-6-17 created

current_dir=$(cd $(dirname "$0"); pwd)
source "${current_dir}/utils.sh"
install_path="$1/DevKit/"


# 删除插件安装目录
function delete_sys_diagnosis() {
    echo_and_log "Delete sys_diagnosis install path" "${DOING}" "${LOG}"
    local sys_diagnosis_path="${install_path}/devkitplugins/sys_diagnosis/"
    if [[ -d "${sys_diagnosis_path}" ]]; then
        rm -rf "${sys_diagnosis_path}"
    fi
    echo_and_log "Delete sys_diagnosis install path success" "${SUCCESS}" "${LOG}"
}

function main() {
    LOG="${install_path}/logs/sys_diagnosis_agent_uninstall.log"
    touch "${LOG}"
    chmod 600 "${LOG}"
    echo_and_log "Uninstalling sys_diagnosis agent" "${DOING}" "${LOG}"
    delete_sudo_tools "${LOG}"
    delete_sys_diagnosis
    echo_and_log "Uninstalling sys_diagnosis agent success" "${SUCCESS}" "${LOG}"
}


main $@
